# Interface CharSequence

All Known Implementing Classes:
  `String, StringBuffer, StringBuilder`

public interface CharSequence
This interface represents an ordered set of characters and defines the methods to probe them.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `char`
  `charAt(int index)`
  Returns the character at the specified index, with the first character having index zero.
  `int`
  `length()`
  Returns the number of characters in this sequence.
  `CharSequence`
  `subSequence(int start, int end)`
  Returns a `CharSequence` from the `start` index (inclusive) to the `end` index (exclusive) of this sequence.
  `String`
  `toString()`
  Returns a string with the same characters in the same order as in this sequence.

- ## Method Details

  - ### length

    int length()

    Returns the number of characters in this sequence.

    ###### Returns

    the number of characters.

  - ### charAt

    char charAt(int index)

    Returns the character at the specified index, with the first character having index zero.

    ###### Parameters

    - `index`: the index of the character to return.

    ###### Returns

    the requested character.

    ###### Throws

    - `IndexOutOfBoundsException`: @throws IndexOutOfBoundsException if `index < 0` or `index` is greater than the length of this sequence.

  - ### subSequence

    CharSequence subSequence(int start, int end)

    Returns a `CharSequence` from the `start` index (inclusive) to the `end` index (exclusive) of this sequence.

    ###### Parameters

    - `start`: @param start the start offset of the sub-sequence. It is inclusive, that is, the index of the first character that is included in the sub-sequence.

    - `end`: @param end the end offset of the sub-sequence. It is exclusive, that is, the index of the first character after those that are included in the sub-sequence

    ###### Returns

    the requested sub-sequence.

    ###### Throws

    - `IndexOutOfBoundsException`: @throws IndexOutOfBoundsException if `start end`, or if `start` or `end` are greater than the length of this sequence.

  - ### toString

    String toString()

    Returns a string with the same characters in the same order as in this sequence.

    ###### Returns

    a string based on this sequence.

    Overrides:
      `toString` in class `java.lang.Object`